//created by Alex Hartley
//this script lets you easily edit tags in Layout on multiple items at once
//-----------------

@version 1.0
@warnings
@script master
@name TagMaster

//global variables
storedDisplayTag,
ignoreCommands,
c1,
c2,
c3,
c4,
c5,
c6,
c7,
tagIdentifier;
parseMode,
userSelect,
currentDisplayTag,
displayTag,
tagIndex,
scene;
//-----------------
create
{
	storedDisplayTag=recall("TagMasterIdentifier");

	tagIdentifier=recall("TagMasterIdentifier");
	if(!tagIdentifier)
		tagIdentifier="XX";

	parseMode=recall("TagMasterParseMode");
	if(!parseMode)
		parseMode=false;

    scene = Scene();
    options();
}    
process: event, command
{
    if(reqisopen())
    {
		if(!ignoreCommands)
		{
			newUserSelect = scene.getSelect();
			if(!userSelect)
			{
				updateList();
				tagSelect(c1);	 
			}

			else if(newUserSelect.size() != userSelect.size() || newUserSelect[1].id!= userSelect[1].id)
			{
				updateList();	
				tagSelect(c1);
			}
		}  
    }	
}
options
{
    reqbegin("tag Master");
    reqsize(232,353);
    c1 = ctllistbox("tags",200,100,"tagCount","tagName","tagEvent");
    ctlposition(c1,8,8,200,200);
    c2 = ctlstring("tag","");
	ctlactive(c1,"tagActive",c2);
    ctlrefresh(c2,"changeTag");
    ctlposition(c2,8,216,200,20);   
    c3 = ctlbutton("add new tag",200, "addTag");
    ctlposition(c3,8,244,96,20);
    c6 = ctlbutton("remove tag",200, "removeTag");
    ctlposition(c6,112,244,96,20);
	ctlactive(c1,"tagActive",c6);
	c7 = ctlbutton("copy tag",200, "copyTag");
    ctlposition(c7,8,272,96,20);
	ctlactive(c1,"tagActive",c7);
    c8 = ctlbutton("paste tag",200, "pasteTag");
    ctlposition(c8,112,272,96,20);
	ctlactive(c1,"storedDisplayTagExists",c8);
    c4 = ctlcheckbox("Parse Mode",parseMode);
    ctlposition(c4,8,300,200,20);
    c5 = ctlstring("Tag Identifier", tagIdentifier);
    ctlposition(c5,8,328,200,20);
    ctlactive(c4,"parseOn",c5);
    ctlrefresh(c5,"changeIdentifier");
        
    reqopen();
}
copyTag
{
	iArray=getvalue(c1);
	i=iArray[1];
	storedDisplayTag = displayTag[i];
	store("storedDisplayTag", storedDisplayTag);
}
storedDisplayTagExists: value
{
	if(value!=nil && storedDisplayTag)
		return(true);
	else
		return(false);	
}
pasteTag
{
	iArray=getvalue(c1);
	i=iArray[1];
	if(storedDisplayTag)
		displayTag[i] = storedDisplayTag;
	saveTags();	
	updateList();
}
tagActive: value
{
if(value!=nil)
	return(true);
else
	return(false);	
}
changeIdentifier: value
{
	tagIdentifier = getvalue(c5);
	store("TagMasterIdentifier", tagIdentifier);
	updateList();
}
parseOn: value
{
	
	parseMode = getvalue(c4);
	store("TagMasterParseMode", parseMode);
	updateList();
	return(value);
}
addTag
{
	if(displayTag)
		i = displayTag.size()+1;
	else
		i=1;

	displayTag[i] = "(new)";
	iArray[1] = i;
	requpdate();
	setvalue(c1,iArray);
	tagSelect(c1);
}
removeTag
{
	iArray=getvalue(c1);
	i=iArray[1];
	displayTag[i]="(tagMaster removeTag)";
	saveTags();	
	updateList();
}
updateList
{
	ignoreCommands=true;
 	displayTag = nil;   
    userSelect = nil;
    userSelect = scene.getSelect();
    tagIndex=nil;
    myTags=nil;
    {
        for(i=1;i<=userSelect.size();i++)
        {
			if(parseMode)
			{
				j=1;
				done=false;
				while (!done)
				{
					fullTag = userSelect[i].getTag(j);
					if(fullTag == nil)
					{
						tagIndex[i] = j;
						done = true;
					}
					else	
						tagParts = parse("=_",fullTag);
					fullTag = nil;
					if(tagParts)
					{
						if (tagParts[1] == tagIdentifier)
						{
							myTags = tagParts;
							tagIndex[i] = j;
							done = true;
						}
					}						
					j++;	
				}       
			}
            j=1;
            done=false;
            tag=nil;
            while(!done)
            {
			    if(parseMode)
			    {
			    	if(myTags)
			    	{
			    		if(myTags.size()>=j)
			    		{
							tag[j] = myTags[j];
			    		}						
			    		else tag[j] = nil;
			    	}
					else tag[j]= nil;
			    }	
            	
            	else
					tag[j] = userSelect[i].getTag(j);
            		    
                if(displayTag)
                {	
                    if(displayTag.size()>=j)
                    {
                        if(tag[j]!=displayTag[j] || tag[j]==nil)
                            displayTag[j] = "(multiple)";	                        	
                    }

                    else if(tag[j]!=nil)
                    	if(i>1)
							displayTag[j] = "(multiple)";	
						else	
							displayTag[j]=tag[j];
                    else
                    	done = true;
                }
                else if(tag[j]==nil)
                	done = true;
                else	
                    displayTag[j]=tag[j];  
                j++;    
            }
        }       
    }
    ignoreCommands = false;
    requpdate();
}
saveTags
{
	ignoreCommands = true;   
	for(i=1;i<=userSelect.size();i++)
	{
		if(parseMode)
		{
			tag = userSelect[i].getTag(tagIndex[i]);
			if(tag)
			{
				tagParts = parse("=_",tag);
				tag=nil;
			}
			else tagParts = nil;	
		}
		else
		{
			tagParts=nil;
			j=1;
			while(userSelect[i].getTag(j))
			{
				tagParts[j]=userSelect[i].getTag(j);
				j++;
			}				
		}            
		k=1;
		size=displayTag.size();
		tempTag=nil;
		for(j=1;j<=size;j++)
		{
			if	(displayTag[j] == "(tagMaster removeTag)")
			{ 
				if(j < displayTag.size())
				{
					k++;
					size--;
				}
				
				else
					displayTag[k]="";			

			}
			if (displayTag[k] != "(multiple)")
				tempTag[j] = displayTag[k];
			else if(tagParts.size()>=k)
				tempTag[j] = tagParts[k];			
		k++;
		}
		if(parseMode)
		{
			for(j=1;j<=tempTag.size();j++)
			{
				if (j==1)
					newTag = tempTag[j];
				else if (j==2)
					newTag = newTag +"="+ tempTag[j];
				else
					newTag = newTag	+"_"+ tempTag[j];            	
			}
			userSelect[i].setTag(tagIndex[i],newTag);
		}
		else
		{
			j=1;
			while(j<=tagParts.size() || j<=tempTag.size())
			{
				if(j<=tempTag.size())
					userSelect[i].setTag(j,tempTag[j]);
				else
					userSelect[i].setTag(j,"");
				j++;
			}
		}
		tempTag=nil;	
	}
   	ignoreCommands = false; 
}
changeTag : value
{
	if(currentDisplayTag && value!=nil)
	{
		name = value;
		if(name != displayTag[currentDisplayTag])
		{
			displayTag[currentDisplayTag] = name;
			saveTags();
			tagSelect(c1);
		}		
	}	
}
tagCount
{
    return(displayTag.size());
}
tagName: index
{
    return(displayTag[index]);
}
tagEvent: iArray
{
        tagSelect(c1);
}
tagSelect: listbox
{
    iArray=nil;
    iArrayNew = getvalue(listbox);
    if(iArrayNew)
    {
			if(iArrayNew.size()>1)   
			iArray[1]=iArrayNew[2];
		else    
			iArray[1]=iArrayNew[1];       
		setvalue(listbox,iArray);
		currentDisplayTag = iArray[1];
		requpdate();    
		setvalue(c2,displayTag[currentDisplayTag]);
    }
	else
	{
		setvalue(listbox,nil);
		requpdate();    
		setvalue(c2,"");
	}
		
}